SystemOrganization addCategory: #'Pier-Jetsam-Debugging'!

!PRContentsWidget methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 8/19/2007 04:14'!
onAnswerCommand: aCommand
	aCommand isNil
		ifTrue: [ ^ self context: (self context structure: self context structure) ].
	[ aCommand execute ]
		on: Error
		do: [ :err | 
			 
			Preferences debugPierFormErrors ifTrue: [ err pass ].
			
			^ self component errors add: err.  ].
	self context: aCommand answer! !

!Object methodsFor: '*pier-jetsam-debugging' stamp: 'kph 8/17/2007 07:36'!
helpfulError: msg

	Preferences helpfulErrors ifTrue: [ self error: msg ].! !

Object subclass: #PRDebugging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Debugging'!

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2008 02:50'!
initialize
 
	Preferences addBooleanPreference: #debugInvalidLogin categories:  self categories default: false balloonHelp: 'Halt when pier login is invalid'.
	
	Preferences addBooleanPreference: #debugPierFormErrors categories:  self categories default: false balloonHelp: 'Halt when pier form validaton error occurs'.
	
	Preferences addBooleanPreference: #ignoreKindValidation categories:  self categories default: false balloonHelp: 'Ignore Magritte Kind Validation'.


 ! !

!PRCommand methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 10/26/2007 17:44'!
execute
	"Execute the command of the receiver. To implement your action in the code of one of my subclasses. Never override this message, but instead have a look at the different template methods (==#doValidate==, ==#doExecute==, ==#doAnswer==) available in the events protocol."

	self log info execute: self.
	
	self assert: self context command == self.
	self isView
		ifTrue: [ self shouldNotImplement ].
	self timestamp: TimeStamp now.
	self kernel persistency
		execute: self.
	self doAnswer! !

!PRCommand methodsFor: '*pier-jetsam-debugging' stamp: 'kph 9/27/2007 22:43'!
printOn: stream

	super printOn: stream.
	stream << $( << self structure printString << $).
	
 ! !

!MAMultipleOptionDescription methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 10/4/2007 15:06'!
validateKind: anObject
 Preferences ignoreKindValidation ifTrue: [ self log warn: 'Kind Validation Ignored'. ^ self  ].
	super validateKind: anObject.
	(anObject allSatisfy: [ :each | self options includes: each ])
		ifFalse: [ MAKindError description: self signal: self kindErrorMessage ]! !

!PRPierFrame methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 10/22/2007 17:08'!
forbiddenRequest: aRequest

	Preferences haltOnForbidden  ifTrue: [ self halt ].

	 self session returnResponse: (WAResponse forbidden: aRequest url)! !

!MADescription methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 9/13/2007 23:13'!
conflictErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #conflictErrorMessage ifAbsent: [ 'Input is conflicting with concurrent modification' ]! !

!MADescription methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 8/19/2007 02:55'!
kindErrorMessage

 
   Preferences debugPierFormErrors ifTrue: [ self halt ].
	^ self propertyAt: #kindErrorMessage ifAbsent: [ 'Invalid input given' ]! !

!MADescription methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 9/13/2007 23:14'!
multipleErrorsMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #multipleErrorsMessage ifAbsent: [ 'Multiple errors' ]! !

!MADescription methodsFor: '*pier-jetsam-debugging-override' stamp: 'kph 9/13/2007 23:14'!
requiredErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #requiredErrorMessage ifAbsent: [ 'Input is required but no input given' ]! !

!WADebugging class methodsFor: '*pier-jetsam-debugging' stamp: 'kph 4/22/2008 02:56'!
preferencesPierMagritte
 
	Preferences addBooleanPreference: #debugInvalidLogin categories:  self categories default: false balloonHelp: 'Halt when pier login is invalid'.
	
	Preferences addBooleanPreference: #debugPierFormErrors categories:  self categories default: false balloonHelp: 'Halt when pier form validaton error occurs'.
	
	Preferences addBooleanPreference: #ignoreKindValidation categories:  self categories default: false balloonHelp: 'Ignore Magritte Kind Validation'.


 ! !
PRDebugging initialize!
